#include "GumballMachine.h"

#include <iostream>

using namespace std;

void GumballMachine::insert_quarter()
{
    if (state == State::HAS_QUARTER)
    {
        cout << "You can't insert another quarter" << endl;
    }
    else if (state == State::NO_QUARTER)
    {
        state = State::HAS_QUARTER;
        cout << "You inserted a quarter" << endl;
    }
    else if (state == State::SOLD_OUT)
    {
        cout << "You can't insert a quarter, the machine is sold out" << endl;
    }
    else if (state == State::SOLD)
    {
        cout << "Please wait, we're already giving you a gumball" << endl;
    }
}

void GumballMachine::eject_quarter()
{
    if (state == State::HAS_QUARTER)
    {
        cout << "Quarter returned" << endl;
        state = State::NO_QUARTER;
    }
    else if (state == State::NO_QUARTER)
    {
        cout << "You haven't inserted a quarter" << endl;
    }
    else if (state == State::SOLD)
    {
        cout << "Sorry, you already turned the crank" << endl;
    }
    else if (state == State::SOLD_OUT)
    {
        cout << "You can't eject, you haven't inserted a quarter yet" << endl;
    }
}

void GumballMachine::turn_crank()
{
    if (state == State::SOLD)
    {
        cout << "Turning twice doesn't get you another gumball!" << endl;
    }
    else if (state == State::NO_QUARTER)
    {
        cout << "You turned but there's no quarter" << endl;
    }
    else if (state == State::SOLD_OUT)
    {
        cout << "You turned, but there are no gumballs" << endl;
    }
    else if (state == State::HAS_QUARTER)
    {
        cout << "You turned..." << endl;
        state = State::SOLD;
        dispense();
    }
}

void GumballMachine::dispense()
{
    if (state == State::SOLD)
    {
        cout << "A gumball comes rolling out the slot" << endl;
        count--;

        if (count == 0)
        {
            cout << "Oops, out of gumballs!" << endl;
            state = State::SOLD_OUT;
        }
        else
        {
            state = State::NO_QUARTER;
        }
    }
    else if (state == State::NO_QUARTER)
    {
        cout << "You need to pay first" << endl;
    }
    else if (state == State::SOLD_OUT)
    {
        cout << "No gumball dispensed" << endl;
    }
    else if (state == State::HAS_QUARTER)
    {
        cout << "No gumball dispensed" << endl;
    }
}

ostream& operator <<(ostream& os, const GumballMachine& gumball_machine)
{
    os << endl;
    os << "Mighty Gumball, Inc." << endl;
    os << "C++-enabled Standing Gumball Model #2004" << endl;

    os << "Inventory: " << gumball_machine.count << " gumball";
    if (gumball_machine.count != -1) cout << "s";
    cout << endl << endl;

    cout << "Machine is ";
    if (gumball_machine.state == State::SOLD_OUT)
    {
        cout << "sold out" << endl;
    }
    else if (gumball_machine.state == State::NO_QUARTER)
    {
        cout << "waiting for quarter";
    }
    else if (gumball_machine.state == State::HAS_QUARTER)
    {
        cout << "waiting for turn of crank";
    }
    else if (gumball_machine.state == State::SOLD)
    {
        cout << "delivering a gumball";
    }
    cout << endl;

    return os;
}
