/**
 * Ported from the Java example program in
 * Head First Design Patterns, 1st edition
 * by Eric Freeman, Bert Bates, and Elizabeth Robson
 * O'Reilly, 2004
 * ISBN 978-0596007126
 *
 * Ported to C++ by:
 * Ronald Mak, Nov. 2019
 * Department of Computer Engineering
 * San Jose State University
 */
#ifndef GUMBALLMACHINE_H_
#define GUMBALLMACHINE_H_

#include <iostream>

using namespace std;

enum class State {SOLD_OUT, NO_QUARTER, HAS_QUARTER, SOLD};

class GumballMachine
{
private:
    State state;  // the current gumball state
    int count;    // how many gumballs left

public:
    GumballMachine(int count) : state(State::SOLD_OUT), count(count)
    {
        if (count > 0) state = State::NO_QUARTER;
    }

    virtual ~GumballMachine() {}

    void insert_quarter();
    void eject_quarter();
    void turn_crank();
    void dispense();

    friend ostream& operator <<(ostream& os, const GumballMachine& gumball);
};

#endif /* GUMBALLMACHINE_H_ */
